import java.io.*;
import java.util.*;

public class grasshopper_aa {
	private static final int INF = (int) 1e9;

	public static void main(String[] args) {
		new grasshopper_aa().run();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;
	Random rand = new Random(125475452);

	private void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	void check(boolean u) {
		if (!u) {
			throw new Error("Assertion failed!!!");
		}
	}

	String FNAME = "grasshopper";

	int MAXN = 1000;
	long MAXK = (long) 1e18;
	String impossible = "Impossible";

	private void solve() throws IOException {
		int n = nextInt();
		check(2 <= n && n <= MAXN);
		long k = nextLong();
		check(0 <= k && k <= MAXK);
		if (k == 0) {
			if (n < 4) {
				out.println(impossible);
			} else {
				out.print("1");
				for (int i = 0; i < n - 2; i++) {
					out.print(" 0");
				}
				out.println(" 1");
			}
			return;
		}
		ArrayList<Integer> good = new ArrayList<Integer>();
		for (int i = 1; i < fib.length; i++) {
			if (k % fib[i] == 0) {
				good.add(i);
			}
		}
		Set<Long> set = new HashSet<Long>();
		for (int i : good) {
			set.add(fib[i]);
			if (fib[i] == 1) {
				continue;
			}
			Long[] a = set.toArray(new Long[set.size()]);
			for (long x : a) {
				long y = x;
				while (1.0 * y * fib[i] <= k) {
					y *= fib[i];
					if (k % y != 0) {
						break;
					}
					set.add(y);
				}
			}
		}
		long[] a = new long[set.size()];
		{
			int size = 0;
			for (long x : set) {
				a[size++] = x;
			}
			Arrays.sort(a);
		}
		HashMap<Long, Integer> hm = new HashMap<Long, Integer>();
		for (int i = 0; i < a.length; i++) {
			hm.put(a[i], i);
		}
		if (!hm.containsKey(k)) {
			out.println(impossible);
			return;
		}
		int[] odd = new int[a.length];
		int[] even = new int[a.length];
		int[] oddLast = new int[a.length];
		int[] evenLast = new int[a.length];
		Arrays.fill(odd, INF);
		Arrays.fill(even, INF);
		for (int i : good) {
			if (i % 2 == 0) {
				even[hm.get(fib[i])] = i;
				evenLast[hm.get(fib[i])] = i;
			} else {
				odd[hm.get(fib[i])] = i;
				oddLast[hm.get(fib[i])] = i;
			}
		}
		for (int i : good) {
			long x = fib[i];
			for (int j = 0; j < a.length; j++) {
				if (1.0 * a[j] * x > k) {
					break;
				}
				long y = a[j] * x;
				if (!hm.containsKey(y)) {
					continue;
				}
				int z = hm.get(y);
				{
					int val = even[j] + 1 + i;
					if (val % 2 == 0) {
						if (even[z] > val) {
							even[z] = val;
							evenLast[z] = i;
						}
					} else {
						if (odd[z] > val) {
							odd[z] = val;
							oddLast[z] = i;
						}
					}
				}
				{
					int val = odd[j] + 1 + i;
					if (val % 2 == 0) {
						if (even[z] > val) {
							even[z] = val;
							evenLast[z] = i;
						}
					} else {
						if (odd[z] > val) {
							odd[z] = val;
							oddLast[z] = i;
						}
					}
				}
			}
		}
		int[] ans = new int[n];
		int top = 0;
		int x = hm.get(k);
		int y = n % 2 == 0 ? even[x] : odd[x];
		if (y > n) {
			out.println(impossible);
			return;
		}
		while (n > y) {
			n -= 2;
			ans[top++] = 1;
			ans[top++] = 0;
		}
		while (n > 0) {
			int last = n % 2 == 0 ? evenLast[x] : oddLast[x];
			k /= fib[last];
			n -= last + 1;
			x = hm.get(k);
			for (int i = 0; i < last; i++) {
				ans[top++] = 1;
			}
			if (top < ans.length) {
				ans[top++] = 0;
			}
		}
		for (int i = 0; i < ans.length; i++) {
			if (i > 0) {
				out.print(" ");
			}
			out.print(ans[i]);
		}
		out.println();
	}

	long[] fib = new long[88];
	{
		fib[1] = 1;
		for (int i = 2; i < fib.length; i++) {
			fib[i] = fib[i - 1] + fib[i - 2];
		}
	}

}