import java.io.*;
import java.util.*;

public class grasshopper_aa_exp {
	public static void main(String[] args) {
		new grasshopper_aa_exp().run();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;
	Random rand = new Random(125475452);

	private void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	void check(boolean u) {
		if (!u) {
			throw new Error("Assertion failed!!!");
		}
	}

	String FNAME = "grasshopper";

	int MAXN = 1000;
	long MAXK = (long) 1e18;
	String impossible = "Impossible";

	private void solve() throws IOException {
		int n = nextInt();
		check(2 <= n && n <= MAXN);
		long k = nextLong();
		check(0 <= k && k <= MAXK);
		if (k == 0) {
			if (n < 4) {
				out.println(impossible);
			} else {
				out.print("1");
				for (int i = 0; i < n - 2; i++) {
					out.print(" 0");
				}
				out.println(" 1");
			}
			return;
		}
		if (n > 30) {
			out.println("Impossible");
			return;
		}
		long[] a = new long[n];
		for (int prof = 0; prof < (1 << n); prof++) {
			if ((prof & 1) == 0 || (prof & (1 << (n - 1))) == 0) {
				continue;
			}
			Arrays.fill(a, 0);
			a[0] = 1;
			for (int i = 1; i < a.length; i++) {
				if ((prof & (1 << i)) == 0) {
					continue;
				}
				a[i] = a[i - 1];
				if (i > 1) {
					a[i] += a[i - 2];
				}
			}
			if (a[n - 1] == k) {
				for (int i = 0; i < a.length; i++) {
					if (i > 0) {
						out.print(" ");
					}
					out.print((prof >> i) & 1);
				}
				out.println();
				return;
			}
		}
		out.println(impossible);
	}

}