import java.io.*;
import java.util.*;

public class grasshopper_aa_group2 {
	private static final int INF = (int) 1e9;

	public static void main(String[] args) {
		new grasshopper_aa_group2().run();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;
	Random rand = new Random(125475452);

	private void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	void check(boolean u) {
		if (!u) {
			throw new Error("Assertion failed!!!");
		}
	}

	String FNAME = "grasshopper";

	int MAXN = 1000;
	long MAXK = (long) 1e18;
	String impossible = "Impossible";

	int B = (int) 8e6 + 1;

	private void solve() throws IOException {
		int n = nextInt();
		check(2 <= n && n <= MAXN);
		long k = nextLong();
		check(0 <= k && k <= MAXK);
		if (k == 0) {
			if (n < 4) {
				out.println(impossible);
			} else {
				out.print("1");
				for (int i = 0; i < n - 2; i++) {
					out.print(" 0");
				}
				out.println(" 1");
			}
			return;
		}
		int[][] a = new int[2][B];
		Arrays.fill(a[0], INF);
		Arrays.fill(a[1], INF);
		int[][] p = new int[2][a[0].length];
		for (int i = 1; i < fib.length; i++) {
			if (fib[i] >= B) {
				break;
			}
			a[i % 2][fib[i]] = i;
			p[i % 2][fib[i]] = i;
		}
		for (int q = 1; q < fib.length; q++) {
			if (fib[q] >= B) {
				break;
			}
			long x = fib[q];
			for (int i = 0; i < a[0].length; i++) {
				for (int j = 0; j < a.length; j++) {
					if (a[j][i] >= INF) {
						continue;
					}
					long y = x * i;
					if (y > a[0].length) {
						continue;
					}
					int val = a[j][i] + q + 1;
					if (a[val % 2][(int) y] > val) {
						a[val % 2][(int) y] = val;
						p[val % 2][(int) y] = q;
					}
				}
			}
		}
		if (a[n % 2][(int) k] > n) {
			out.println(impossible);
			return;
		}
		int[] ans = new int[n];
		int top = 0;
		while (n > a[n % 2][(int) k]) {
			n -= 2;
			ans[top++] = 1;
			ans[top++] = 0;
		}
		while (n > 0) {
			int last = p[n % 2][(int) k];
			k /= fib[last];
			n -= last + 1;
			for (int i = 0; i < last; i++) {
				ans[top++] = 1;
			}
			if (top < ans.length) {
				ans[top++] = 0;
			}
		}
		for (int i = 0; i < ans.length; i++) {
			if (i > 0) {
				out.print(" ");
			}
			out.print(ans[i]);
		}
		out.println();
	}

	int[] fib = new int[45];
	{
		fib[1] = 1;
		for (int i = 2; i < fib.length; i++) {
			fib[i] = fib[i - 1] + fib[i - 2];
		}
	}

}