import java.io.*;
import java.util.*;

public class grasshopper_aa_slow {
	public static void main(String[] args) {
		new grasshopper_aa_slow().run();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;
	Random rand = new Random(125475452);

	private void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	void check(boolean u) {
		if (!u) {
			throw new Error("Assertion failed!!!");
		}
	}

	String FNAME = "grasshopper";

	int MAXN = 1000;
	long MAXK = (long) 1e18;
	long BOUND = (long) 1e10;
	String impossible = "Impossible";

	private void solve() throws IOException {
		int n = nextInt();
		check(2 <= n && n <= MAXN);
		long k = nextLong();
		check(0 <= k && k <= MAXK);
		if (k == 0) {
			if (n < 4) {
				out.println(impossible);
			} else {
				out.print("1");
				for (int i = 0; i < n - 2; i++) {
					out.print(" 0");
				}
				out.println(" 1");
			}
			return;
		}
		if (!map.containsKey(k)) {
			out.println(impossible);
			return;
		}
		int[] ans = new int[n];
		int top = 0;
		int x = map.get(k);
		int y = n % 2 == 0 ? even[x] : odd[x];
		if (y > n) {
			out.println(impossible);
			return;
		}
		while (n > y) {
			n -= 2;
			ans[top++] = 1;
			ans[top++] = 0;
		}
		while (n > 0) {
			int last = n % 2 == 0 ? evenLast[x] : oddLast[x];
			k /= fib[last];
			n -= last + 1;
			x = map.get(k);
			for (int i = 0; i < last; i++) {
				ans[top++] = 1;
			}
			if (top < ans.length) {
				ans[top++] = 0;
			}
		}
		for (int i = 0; i < ans.length; i++) {
			if (i > 0) {
				out.print(" ");
			}
			out.print(ans[i]);
		}
		out.println();
	}

	int CONST = 10000000;
	int INF = (int) 1e9;
	Map<Long, Integer> map;
	long[] fib = new long[88];
	int[] odd, oddLast, even, evenLast;
	{
		fib[1] = 1;
		for (int i = 2; i < fib.length; i++) {
			fib[i] = fib[i - 1] + fib[i - 2];
		}
		Set<Long> set = new HashSet<Long>();
		long[] stack = new long[CONST];
		for (int i = 2; i < fib.length; i++) {
			if (fib[i] > BOUND) {
				break;
			}
			set.add(fib[i]);
			if (fib[i] > 1) {
				int top = 0;
				for (Long x : set) {
					stack[top++] = x;
				}
				for (int q = 0; q < top; q++) {
					long x = stack[q];
					while (true) {
						set.add(x);
						if (1.0 * x * fib[i] > BOUND) {
							break;
						}
						x *= fib[i];
					}
				}
			}
		}
		long[] a = new long[set.size()];
		{
			int size = 0;
			for (long x : set) {
				a[size++] = x;
			}
		}
		Arrays.sort(a);
		map = new HashMap<Long, Integer>();
		for (int i = 0; i < a.length; i++) {
			map.put(a[i], i);
		}
		int n = map.size();
		odd = new int[n];
		oddLast = new int[n];
		even = new int[n];
		evenLast = new int[n];
		Arrays.fill(odd, INF);
		Arrays.fill(even, INF);
		for (int i = 1; i < fib.length && fib[i] <= BOUND; i++) {
			int x = map.get(fib[i]);
			if (i % 2 == 0) {
				even[x] = i;
				evenLast[x] = i;
			} else {
				odd[x] = i;
				oddLast[x] = i;
			}
		}
		for (int i = 1; i < fib.length && fib[i] <= BOUND; i++) {
			for (int j = 0; j < even.length; j++) {
				long key = fib[i] * a[j];
				if (key > BOUND) {
					break;
				}
				int x = map.get(key);
				int last = i;
				{
					int value = even[j] + 1 + i;
					if (value % 2 == 0) {
						if (even[x] > value) {
							even[x] = value;
							evenLast[x] = last;
						}
					} else {
						if (odd[x] > value) {
							odd[x] = value;
							oddLast[x] = last;
						}
					}
				}
				{
					int value = odd[j] + 1 + i;
					if (value % 2 == 0) {
						if (even[x] > value) {
							even[x] = value;
							evenLast[x] = last;
						}
					} else {
						if (odd[x] > value) {
							odd[x] = value;
							oddLast[x] = last;
						}
					}
				}
			}
		}
	}

}