import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Random;

public class gen_grasshopper {
	public static void main(String[] args) {
		new gen_grasshopper().genTests();
	}

	Random rand = new Random(98233);
	int test = 0;
	String fname;
	PrintWriter out;
	final int MAXN = 1000;
	final int SMALLN = 20;
	final long MAXK = (long) 1e18;
	final long MAXK2 = (long) 1e6;

	private void next() {
		finish();
		test++;
		fname = (test / 10) + "" + (test % 10);
		try {
			out = new PrintWriter(fname);
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
		System.out.println(fname);
	}

	private void finish() {
		if (out != null) {
			out.close();
		}
	}

	private void genTests() {
		superSmallTests();
		otherTests();
		finish();
	}

	private void superSmallTests() {
		smallImpossibleTests();
		smallZeroTests();
		otherSmallTests();
	}

	private void smallImpossibleTests() {
		next();
		out.println("2 0");
		next();
		out.println("20 256");
		next();
		out.println("10 25");
		next();
		out.println("19 195");
	}

	private void smallZeroTests() {
		next();
		out.println("13 0");
	}

	private void otherSmallTests() {
		next();
		out.println("2 1");
		next();
		out.println("20 " + f[20]);
		next();
		out.println("19 " + f[19]);
		while (test < 20) {
			next();
			int n = 2 + rand.nextInt(19);
			long x = genValidNumber(n, MAXK);
			out.println(n + " " + x);
		}
	}

	private void otherTests() {
		impossibleTests();
		zeroTests();
		bigTests();
	}

	private void impossibleTests() {
		next();
		out.println((7 * 19 + 6) + " " + (1L << (3 * 19 + 2)));
		next();
		out.println(f.length + " " + f[f.length - 1]);
		next();
		int x = 50 + rand.nextInt(f.length - 50);
		out.println(x - 1 + " " + f[x]);
		next();
		out.println("997 " + nextLong(MAXK));
	}

	private long nextLong(long n) {
		long x = (rand.nextLong() % n + n) % n;
		return x;
	}

	private void zeroTests() {
		next();
		out.println("255 0");
	}

	private void bigTests() {
		for (int i = 0; i < 1; i++) {
			next();
			int n = 200 + rand.nextInt(MAXN - 200 + 1);
			out.println(n + " " + getMaxValid(n + 1));
		}
		next();
		out.println("1000 " + getMaxValid(1001));
		for (int i = 0; i < 1; i++) {
			next();
			int x = 50 + rand.nextInt(f.length - 50);
			int y = x + rand.nextInt(MAXN - x);
			out.println(y + " " + f[x]);
		}
		next();
		out.println("94 23254532864640");
		next();
		out.println("83 62923189521024");
		next();
		out.println("508 812967657313788144");
		next();
		out.println("906 50252789454377328");
		next();
		out.println("997 507417521086288512");
		next();
		out.println("998 909082780609706640");
		next();
		out.println("182 952003847289390336");
		next();
		out.println("120 959578153174040400");
		next();
		out.println("156 997920504580839840");
		next();
		out.println("230 972100180204544160");
		next();
		out.println(MAXN + " " + MAXK);
		next();
		out.println("999 " + f[f.length - 1]);
		for (int i = 0; i < 7; i++) {
			next();
			int n = 100 + rand.nextInt(MAXN - 100 + 1);
			out.println(n + " " + genValidNumber(n, MAXK2));
		}
		next();
		out.println(MAXN + " " + MAXK2);
		while (test < 50) {
			next();
			int n = 200 + rand.nextInt(MAXN - 200 + 1);
			if (test == 50) {
				n = 1000;
			}
			out.println(n + " " + genValidNumber(n, MAXK));
		}
	}

	long[] maxValid = new long[1002];
	{
		Arrays.fill(maxValid, -1);
	}

	private long getMaxValid(int n) {
		if (maxValid[n] >= 0) {
			return maxValid[n];
		}
		long max = 1;
		for (int i = 1; i < Math.min(n, f.length); i++) {
			long vvv = getMaxValid(n - i - 1);
			double v = 1.0 * f[i] * vvv;
			if (v > MAXK) {
				continue;
			}
			long val = f[i] * vvv;
			max = Math.max(max, val);
		}
		maxValid[n] = max;
		return max;
	}

	private long genValidNumber(int n, long BOUND) {
		int q = n;
		n++;
		long x = 1;
		int k = rand.nextInt(20);
		while (k-- > 0) {
			int z = 1 + rand.nextInt(f.length - 1);
			long y = f[z];
			if (n >= z + 1 && 1.0 * x * y <= BOUND) {
				x *= y;
				n -= z + 1;
			}
		}
		if (n > 100 && x < MAXK2 && BOUND > MAXK2) {
			return genValidNumber(q, BOUND);
		}
		return x;
	}

	long[] f = new long[88];
	{
		f[1] = 1;
		for (int i = 2; i < f.length; i++) {
			f[i] = f[i - 1] + f[i - 2];
		}
	}

}
